----------------------------------------------------------------
-- Euclidean mod P addition (Euclidean_mod_p_division.adb)
-- 
-- compute: Z = X/Y mod P
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields; use finite_fields;
procedure Euclidean_mod_p_division is 
p, x, y, z, a, b, c, d, q, r, next_d: integer;
begin
loop
Put("p = "); Get(p); New_Line;
Put("x = "); Get(x); New_Line;
Put("y = "); Get(y); New_Line;
----------------------------------------------
a := p; b := y; c := 0; d := x;
while b > 1 loop
   q := a/b; r := a mod b; next_d := (c - d*q);
   a := b; b := r; c := d; d := next_d;
end loop;
z := d mod p;
----------------------------------------------
Put(d); New_Line;
Put(x); Put(" / "); Put(y); Put(" mod "); Put(p); Put(" = "); Put(z); New_Line; New_Line;
end loop;
end Euclidean_mod_p_division;