----------------------------------------------------------------
-- Fermats little teorem mod p division algorithm (Fermat_division.adb)
-- 
-- compute: Z = X/Y mod P
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields; use finite_fields;
procedure Fermat_division is 
x, y, q, e, tx, ty, z: integer;
binary_p_minus_2: bit_vector(0 .. k-1);
begin
loop
Put("x = "); Get(x); New_Line;
Put("y = "); Get(y); New_Line;
q := m-2;
for i in 0 .. k-1 loop binary_p_minus_2(i) := q mod 2; q := q/2; end loop; 
-----------------------------------------------------------------
e := exp_k;
tx := mp(x, exp_2k);
ty := mp(y, exp_2k);
for i in 1 .. k loop
 e := mp(e, e);
 if binary_p_minus_2(k-i) = 1 then e := mp(e, ty); end if;
end loop;
e := mp(e, tx);
z := mp(e, 1);
----------------------------------------------
Put(x); Put(" / "); Put(y); Put(" mod "); Put(m); Put(" = "); Put(z); New_Line; New_Line;
end loop;
end Fermat_division;