----------------------------------------------------------------
-- Binary Division Algorithm (binary_algorithm.adb)
-- 
-- compute: Z = X/Y mod P
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields; use finite_fields;
procedure binary_algorithm is
   X, Y, P, Z, a, b, c, d, Old_b, Old_d: Integer;   
begin
loop
   Put("p = "); Get(P); New_Line;
   Put("x = "); Get(X); New_Line;
   Put("y = "); Get(Y); New_Line;
---------------------------------------------------------------------
   a := p; b := y; c := 0; d := x;
   while a > 1 loop
      while (b mod 2) = 0 loop 
         b := b/2; d := Divide_By_2(d, P); 
      end loop;
      if b >= a then 
         b := b-a; d := (d-c) mod P; 
      else 
         Old_b := b; b := a-b; a := Old_b;
         Old_d := d; d := (c-d) mod P; c := Old_d;
      end if;
   end loop;
   Z := c;
----------------------------------------------------------------------
   Put(X);Put("/"); Put(Y); Put(" mod "); Put(P); Put(" = "); Put(Z);  New_Line; New_Line; 
end loop;     
end binary_algorithm;

