----------------------------------------------------------------
-- Non-restoring divider (nr_divider.adb)
-- 
-- calculate: A/B 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields; use finite_fields;
procedure nr_divider is

a, b, y, s, r, quotient, remainder, acc: integer;
q: bit_vector(0 .. k);
begin
loop
Put("a = "); Get(a);   
Put("b = "); Get(b);    
----------------------------------------------------------------------
y := b*(2**(k-2));
s := a;
for i in 1 .. k-1 loop
   if s < 0 then q(k-i) := 0; r := s + y;
   else q(k-i) := 1; r := s - y;
   end if;
   s := 2*r;
end loop;
remainder := r / (2**(k-2));
q(k-1) := 1 - q(k-1); q(0) := 1;
acc := 0; 
for i in 0 .. k-2 loop acc := acc + (q(i)*(2**i)); end loop;
acc := acc - (q(k-1)*(2**(k-1)));
if remainder < 0 then quotient := acc -1; remainder := remainder + b; 
else quotient := acc; end if;
---------------------------------------------------------------------------
Put(a); Put(" / "); Put(b); Put(" = "); Put(quotient); Put("."); Put(b); Put(" + "); Put(remainder); New_Line; New_Line;
end loop;
end nr_divider;





